package meerkat.crypto.mixnet;

import com.google.protobuf.InvalidProtocolBufferException;
import meerkat.protobuf.Crypto;
import meerkat.protobuf.Mixing;

/**
 * Prove in zero knowledge that two ciphertexts are a mix of two original ciphertexts.
 */
public interface Mix2ZeroKnowledgeProver {
    public Mixing.Mix2Proof prove(Crypto.RerandomizableEncryptedMessage in1,
                                  Crypto.RerandomizableEncryptedMessage in2,
                                  Crypto.RerandomizableEncryptedMessage out1,
                                  Crypto.RerandomizableEncryptedMessage out2,
                                  boolean switched, int layer, int switchIdx, int out0Idx, int out1Idx, // switch info
                                  Crypto.EncryptionRandomness r1,
                                  Crypto.EncryptionRandomness r2) throws InvalidProtocolBufferException;


}
